﻿namespace CachedDelegates {

    delegate int BinaryOpDelegate(int a, int b);
    
    class Program {

        static int Add(int a, int b) => a + b;

        static int Mul(int first, int second) => first * second;
        
        static void Main(string[] args) {
            var d1 = new BinaryOpDelegate(Add);
            Console.WriteLine(d1.Invoke(2, 3));
            Console.WriteLine(d1(2, 3));

            d1 = new BinaryOpDelegate(Mul);
            Console.WriteLine(d1(2, 3));

            BinaryOpDelegate[] two = new BinaryOpDelegate[2];
            for (int i = 0; i < two.Length; i++) {
                two[i] = new BinaryOpDelegate(Mul);
            }
            Console.WriteLine(object.ReferenceEquals(two[0], two[1]));

            for (int i = 0; i < two.Length; i++) {
                two[i] = Mul;
            }
            Console.WriteLine(object.ReferenceEquals(two[0], two[1]));
        }
    }
}