﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Delegates {

	delegate void Proc(int a);

	class A {
		public int m;

		public void f(int x) {
			Console.WriteLine("instance A.f(x == {0}): m == {1}", x, m);
		}

		public static void g(int x) {
			Console.WriteLine("static A.g(x == {0})", x);
		}

		private static void privateH(int x) {
			Console.WriteLine("private static A.g(x == {0})", x);
		}

		public static Proc UsefulMethod => new Proc(privateH);
	}

	class Program {
		static void Main(string[] args) {
			A a1 = new A { m = 1 };
			A a2 = new A { m = 2 };

			Proc p;
			p = new Proc(A.g);
			p(10);

			p = A.UsefulMethod;
			p(11);

			p = new Proc(a1.f);
			p(20);

			p = a2.f;
			p(25);

			a2 = a1;
			p(26);

			p = null;
			try {
				p(30);
			} catch (Exception ex) {
				Console.WriteLine(ex);
			}

            Console.WriteLine();

			B b = new B { m = 1 };
			Console.WriteLine(b.m);

			b.Add(10);
			Console.WriteLine(b.m);
			
			Proc p2 = b.Add;
			p2(100);
			Console.WriteLine(b.m);
		}
	}

	struct B {
		public int m;

		public void Add(int x) {
			m += x;
            Console.WriteLine($"B.Add called: final value of m == {m}");
        }
	}
}
